#include <bits/stdc++.h>

using namespace std;


#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rep(i, a, b) for(ll (i) = a; i < b; i ++)
#define repr(i, a, b) for(ll (i) = a; i > b; i --)
typedef long long ll;

ll Asum = 0;
ll n, m;

ll getVS1(ll v) {
//    v - number of first elem of second part
    ll arifsum = (v * (v - 1)) / 2 * n;
    ll rows = (v - 1) * m * ((n - 1) * n) / 2;
    return arifsum + rows;
}

ll getVS2(ll v) {
//    v - number
    return Asum - getVS1(v);
}

ll getHS1(ll v) {
    ll k = m * (v - 1);
    ll sum = (k * (k + 1)) / 2;
    return sum;
}

ll getHS2(ll v) {
    return Asum - getHS1(v);
}

ll solve() {
    cin >> n >> m;
    Asum = ((n * m) * (n * m + 1)) / 2;
    ll min_raz = LLONG_MAX, ans_ind;
    char ans_char;
//    po V
    // S1 >= S2
    ll l = 0, r = m + 1;
    ll cs1, cs2;
    while(r - l > 1){
        ll mid = (l + r) / 2;
        ll s1 = getVS1(mid), s2 = getVS2(mid);
        if(s1 >= s2){
            r = mid;
        } else {
            l = mid;
        }
    }
    cs1 = getVS1(r), cs2 = getVS2(r);
    if(min_raz > abs(cs1 - cs2)){
        min_raz = abs(cs1 - cs2);
        ans_ind = r;
        ans_char = 'V';
    }
    // S2 >= S1
    l = 0, r = m + 1;
    while(r - l > 1){
        ll mid = (l + r) / 2;
        ll s1 = getVS1(mid), s2 = getVS2(mid);
        if(s2 >= s1){
            l = mid;
        } else {
            r = mid;
        }
    }
    cs1 = getVS1(l), cs2 = getVS2(l);
    if(min_raz > abs(cs1 - cs2)){
        min_raz = abs(cs1 - cs2);
        ans_ind = l;
        ans_char = 'V';
    }

//  po H
    l = 0, r = n + 1;
    while(r - l > 1){
        ll mid = (l + r) / 2;
        ll s1 = getHS1(mid), s2 = getHS2(mid);
        if(s1 >= s2){
            r = mid;
        } else {
            l = mid;
        }
    }
    cs1 = getHS1(r), cs2 = getHS2(r);
    if(min_raz > abs(cs1 - cs2)){
        min_raz = abs(cs1 - cs2);
        ans_ind = r;
        ans_char = 'H';
    }
    l = 0, r = n + 1;
    while(r - l > 1){
        ll mid = (l + r) / 2;
        ll s1 = getHS1(mid), s2 = getHS2(mid);
        if(s2 >= s1){
            l = mid;
        } else {
            r = mid;
        }
    }
    cs1 = getHS1(l), cs2 = getHS2(l);
    if(min_raz > abs(cs1 - cs2)){
        min_raz = abs(cs1 - cs2);
        ans_ind = l;
        ans_char = 'H';
    }
    assert(ans_ind > 0);
    if(ans_char == 'V'){
        assert(ans_ind <= m);
    } else {
        assert(ans_ind <= n);
    }
    cout << ans_char << " " << ans_ind << "\n";
    return 0;
}

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    ll tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
