#include <bits/stdc++.h>

#include <random>

#define rep(i, a, b) for(ll (i) = a; i < b; i ++)
#define repr(i, a, b) for(ll (i) = a; i > b; i --)
#define all(x) (x).begin(), (x).end()
using namespace std;

typedef long long ll;

const ll MOD = 1e9 + 7;

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
//    srand(time(0));

    string a, b, c;
    cin >> a >> b >> c;
    vector<ll> p(a.size());
    rep(i, 0, a.size()) {
        p[i] = i;
    }
    ll cnt = 0;
    set<vector<ll>> st;
    double start = clock();
    ll n = a.size();
    do {
        shuffle(all(p), std::mt19937(std::random_device()()));
        if (a[p[0]] == '0' || b[p[0]] == '0' || c[p[0]] == '0' ||
            ((a[p[n - 1]] - '0' + b[p[n - 1]] - '0') % 10) != c[p[n - 1]] - '0') {
            continue;
        }
        ll a1 = 0, b1 = 0, c1 = 0;
        rep(i, 0, a.size()) {
            a1 *= 10;
            b1 *= 10;
            c1 *= 10;

            a1 += a[p[i]] - '0';
            b1 += b[p[i]] - '0';
            c1 += c[p[i]] - '0';
        }
        if (a1 + b1 == c1) {
            st.insert(p);
        }
    } while (clock() - start < 1000);
    cout << st.size() % MOD;
    return 0;
}