#include <bits/stdc++.h>

#define rep(i, a, b) for(ll (i) = a; i < b; i ++)
#define repr(i, a, b) for(ll (i) = a; i > b; i --)
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define F first
#define S second
using namespace std;

typedef long long ll;

const ll MOD = 1e9 + 7;

ll n, m, c;
vector<vector<ll>> mat;
vector<vector<ll>> ans;
vector<vector<ll>> good;
vector<pair<ll, ll>> inds;
ll f = 0, yl, xl;

bool check() {
    rep(y1, 0, n) {
        rep(y2, y1 + 1, n) {
            rep(x1, 0, m) {
                rep(x2, x1 + 1, m) {
                    ll cnt = 1;
                    cnt += (mat[y2][x1] == mat[y1][x1]);
                    cnt += (mat[y1][x2] == mat[y1][x1]);
                    cnt += (mat[y2][x2] == mat[y1][x1]);
                    if (cnt == 4) {
                        return false;
                    }
                }
            }
        }
    }
    return true;
}

void add() {

}

void gen(ll ind) {
    if (f) return;
    if (ind == inds.size()) {
//        all squares done
        if (n % 2 || m % 2) {
            add();
        }
        if (check()) {
            ans = mat;
            f = 1;
        }
        return;
    }
    ll y = inds[ind].F, x = inds[ind].S;
    rep(i, 0, good.size()) {
        mat[y][x] = good[i][0];
        mat[y][x + 1] = good[i][1];
        mat[y + 1][x] = good[i][2];
        mat[y + 1][x + 1] = good[i][3];
        gen(ind + 1);
    }
}

void get_good(vector<ll> &cur) {
    if (cur.size() == 4) {
        set<ll> st;
        rep(i, 0, cur.size()) {
            st.insert(cur[i]);
        }
        if (st.size() > 1) {
            good.push_back(cur);
        }
        return;
    }
    rep(color, 1, c + 1) {
        cur.push_back(color);
        get_good(cur);
        cur.pop_back();
    }
}


signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m >> c;
    vector<ll> cur;
    get_good(cur);
    mat.resize(n, vector<ll>(m));
    rep(i, 0, n) {
        if (i == n - 1) break;
        rep(j, 0, m) {
            if (j == m - 1) break;
            inds.push_back({i, j});
            j++;
        }
        i++;
    }
    gen(0);
    rep(i, 0, n) {
        rep(j, 0, m) {
            cout << ans[i][j] << " ";
        }
        cout << "\n";
    }
    return 0;
}